/**
 * Reseplaneraren
 * Provides access to Västtrafik journey planner
 *
 * OpenAPI spec version: 1.10.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Reseplaneraren) {
      root.Reseplaneraren = {};
    }
    root.Reseplaneraren.JourneyType = factory(root.Reseplaneraren.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The JourneyType model module.
   * @module model/JourneyType
   * @version 1.10.1
   */

  /**
   * Constructs a new <code>JourneyType</code>.
   * @alias module:model/JourneyType
   * @class
   * @param routeIdxTo {Number} End of validity on total route.
   * @param routeIdxFrom {Number} Start of validity on total route
   * @param type {String} The attribute type specifies the type of the journey. Valid values are VAS, LDT (Long Distance Train), REG (Regional train), BUS , BOAT, TRAM, TAXI (Taxi/Telebus)
   */
  var exports = function(routeIdxTo, routeIdxFrom, type) {
    var _this = this;

    _this['routeIdxTo'] = routeIdxTo;
    _this['routeIdxFrom'] = routeIdxFrom;
    _this['type'] = type;
  };

  /**
   * Constructs a <code>JourneyType</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/JourneyType} obj Optional instance to populate.
   * @return {module:model/JourneyType} The populated <code>JourneyType</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('routeIdxTo')) {
        obj['routeIdxTo'] = ApiClient.convertToType(data['routeIdxTo'], 'Number');
      }
      if (data.hasOwnProperty('routeIdxFrom')) {
        obj['routeIdxFrom'] = ApiClient.convertToType(data['routeIdxFrom'], 'Number');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
    }
    return obj;
  }

  /**
   * End of validity on total route.
   * @member {Number} routeIdxTo
   */
  exports.prototype['routeIdxTo'] = undefined;
  /**
   * Start of validity on total route
   * @member {Number} routeIdxFrom
   */
  exports.prototype['routeIdxFrom'] = undefined;
  /**
   * The attribute type specifies the type of the journey. Valid values are VAS, LDT (Long Distance Train), REG (Regional train), BUS , BOAT, TRAM, TAXI (Taxi/Telebus)
   * @member {String} type
   */
  exports.prototype['type'] = undefined;



  return exports;
}));


