/**
 * Reseplaneraren
 * Provides access to Västtrafik journey planner
 *
 * OpenAPI spec version: 1.10.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.Reseplaneraren) {
      root.Reseplaneraren = {};
    }
    root.Reseplaneraren.Note = factory(root.Reseplaneraren.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Note model module.
   * @module model/Note
   * @version 1.10.1
   */

  /**
   * Constructs a new <code>Note</code>.
   * @alias module:model/Note
   * @class
   * @param priority {String} Priority of the note which can be used to order the notes in the list.
   * @param severity {module:model/Note.SeverityEnum} Severity of this note, can be high, normal or low
   */
  var exports = function(priority, severity) {
    var _this = this;

    _this['priority'] = priority;
    _this['severity'] = severity;

  };

  /**
   * Constructs a <code>Note</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Note} obj Optional instance to populate.
   * @return {module:model/Note} The populated <code>Note</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('priority')) {
        obj['priority'] = ApiClient.convertToType(data['priority'], 'String');
      }
      if (data.hasOwnProperty('severity')) {
        obj['severity'] = ApiClient.convertToType(data['severity'], 'String');
      }
      if (data.hasOwnProperty('key')) {
        obj['key'] = ApiClient.convertToType(data['key'], 'String');
      }
    }
    return obj;
  }

  /**
   * Priority of the note which can be used to order the notes in the list.
   * @member {String} priority
   */
  exports.prototype['priority'] = undefined;
  /**
   * Severity of this note, can be high, normal or low
   * @member {module:model/Note.SeverityEnum} severity
   */
  exports.prototype['severity'] = undefined;
  /**
   * Type of this note
   * @member {String} key
   */
  exports.prototype['key'] = undefined;


  /**
   * Allowed values for the <code>severity</code> property.
   * @enum {String}
   * @readonly
   */
  exports.SeverityEnum = {
    /**
     * value: "high"
     * @const
     */
    "high": "high",
    /**
     * value: "normal"
     * @const
     */
    "normal": "normal",
    /**
     * value: "low"
     * @const
     */
    "low": "low"  };


  return exports;
}));


